package lexer;

import java.lang.*;
import java.io.*;

public class Lex {
   Input input; 

   public Lex(String filename) throws IOException {
      input = new Input(filename);
   }

   public Token nextToken () {
      int state = LexTable.STARTSTATE;
      while (true) {
         int c = input.current();
//         System.out.println("state=" + state + "; char=" + c + "; advance=" + LexTable.ADVANCE[state][Char.classify(c)]);
         LexTable.action(state,input);
         if (LexTable.ACCEPT[state]) {
            int tok = LexTable.TOKEN[state];
            if (tok == Token.IDENT)
               tok = Token.keyword(LexTable.tokenValue());
            return new Token(tok,LexTable.tokenStart(),LexTable.tokenValue());
         }
         int charKind = Char.classify(c);
         int newstate = LexTable.NEXTSTATE[state][charKind];
         if (LexTable.ADVANCE[state][charKind]) 
            input.advance();
         state = newstate;
      }
   }


   public static void main (String args[]) throws IOException{
      Lex scanner = new Lex(args[0]);
      System.out.println("<block>");
      while(true) {
         Token token = scanner.nextToken();
         System.out.println("   " + token.toString());
         if (token.kind == Token.EOF) break;
      }
      System.out.println("</block>");
   }

}
